      program thload_tri
c
      dimension x(10),y(10),DNDXI(10),DNDETA(10)
      dimension axi(10),aeta(10),H(10),sig(4)
      dimension press(8,2)
      dimension bt(20,3),b(3,20)
      real N(10),JM(2,2),JINV(2,2)
      data x(1),y(1),x(2),y(2)/0.0,0.0,0.5,0.0/
      data x(3),y(3),x(4),y(4)/1.0,0.0,0.5,0.5/
      data x(5),y(5),x(6),y(6)/0.0,1.0,0.0,0.5/
c
ccccc setting initial stress
c  initial stress is defined at each integration points
c
      sig(1) = 1.0
      sig(2) = 1.0
      sig(3) = 0.0
      sig(4) = 0.0
c
      do 2 i = 1,6
         press(i,1)=0.0
         press(i,2)=0.0
 2    continue
c
C   set integration order
      NGAUSS = 2
c
      IF (NGAUSS .EQ. 2 ) THEN
      NG = 3
      A1=1.0/6.0
      A2=2.0/3.0
      DO 60 I=1,3
      H(I)=1.0/6.0
  60  CONTINUE
      AXI(1)=A1
      AETA(1)=A1
      AXI(2)=A2
      AETA(2)=A1
      AXI(3)=A1
      AETA(3)=A2
c
      ELSE  IF (NGAUSS .EQ. 3 ) THEN
      NG = 4
      AXI(1)=1.0/3.0
      AETA(1)=1.0/3.0
      H(1)=-27.0/96.0
      AXI(2)=0.2
      AETA(2)=0.2
      H(2)=25.0/96.0
      AXI(3)=0.6
      AETA(3)=0.2
      H(3)=25.0/96.0
      AXI(4)=0.2
      AETA(4)=0.6      
      H(4)=25.0/96.0
c
      ENDIF
c
ccccccc each integration points
      DO 100 I = 1, NG
c
      XI = AXI(I)
      ETA= AETA(I)
c
      RM=1.0-XI-ETA
c <N>
      N(1)=-RM*(1.0-2.0*RM)
      N(2)=4.0*XI*RM
      N(3)=-XI*(1.0-2.0*XI)
      N(4)=4.0*XI*ETA
      N(5)=-ETA*(1.0-2.0*ETA)
      N(6)=4.0*ETA*RM
c <dN/dXI>     
      DNDXI(1)=1.0-4.0*RM
      DNDXI(2)=4.0*(RM-XI)
      DNDXI(3)=-1.0+4.0*XI
      DNDXI(4)=4.0*ETA
      DNDXI(5)=0.0
      DNDXI(6)=-4.0*ETA
c <dN/dETA>     
      DNDETA(1)=1.0-4.0*RM
      DNDETA(2)=-4.0*XI
      DNDETA(3)=0.0
      DNDETA(4)=4.0*XI
      DNDETA(5)=-1.0+4.0*ETA
      DNDETA(6)=4.0*(RM-ETA)
c
C CALCULATE J-MAT (FOR 2-DIMENSION)
       JM(1,1)=0
       JM(2,1)=0
       JM(1,2)=0
       JM(2,2)=0
       DO 10 J=1,6
       JM(1,1)=JM(1,1)+DNDXI(J)*X(J)
       JM(2,1)=JM(2,1)+DNDETA(J)*X(J)
       JM(1,2)=JM(1,2)+DNDXI(J)*Y(J)
       JM(2,2)=JM(2,2)+DNDETA(J)*Y(J)
 10    CONTINUE
c
        DETJ=JM(1,1)*JM(2,2)-JM(1,2)*JM(2,1)
c
        JINV(1,1)= 1.0/DETJ*JM(2,2)
        JINV(2,1)=-1.0/DETJ*JM(2,1)
        JINV(1,2)=-1.0/DETJ*JM(1,2)
        JINV(2,2)= 1.0/DETJ*JM(1,1)
c       write(6,1001)JM(1,1),JM(1,2)
c       write(6,1001)JM(2,1),JM(2,2)
c
         w = H(I)
c
      DO 70 KK=1,6
      I1 = 2*KK-1
      I2 = 2*KK
ccccc setting BMATRIX,BTMATRIX
c      B(1,I1)=JINV(1,1)*DNDXI(KK)+JINV(1,2)*DNDETA(KK)
c      B(1,I2)=0.0
      BT(I1,1)=JINV(1,1)*DNDXI(KK)+JINV(1,2)*DNDETA(KK)
      BT(I2,1)=0.0
c      B(2,I1)=0.0
c      B(2,I2)=JINV(2,1)*DNDXI(KK)+JINV(2,2)*DNDETA(KK)
      BT(I1,2)=0.0
      BT(I2,2)=JINV(2,1)*DNDXI(KK)+JINV(2,2)*DNDETA(KK)
c      B(3,I1)=JINV(2,1)*DNDXI(KK)+JINV(2,2)*DNDETA(KK)
c      B(3,I2)=JINV(1,1)*DNDXI(KK)+JINV(1,2)*DNDETA(KK)
      BT(I1,3)=JINV(2,1)*DNDXI(KK)+JINV(2,2)*DNDETA(KK)
      BT(I2,3)=JINV(1,1)*DNDXI(KK)+JINV(1,2)*DNDETA(KK)
       fx = -(BT(I1,1)*sig(1)+BT(I1,2)*sig(2)+BT(I1,3)*sig(3))
       fy = -(BT(I2,1)*sig(1)+BT(I2,2)*sig(2)+BT(I2,3)*sig(3))
c       write(6,*)fx,fy,w,detj
       press(kk,1)= press(kk,1) + fx * w * detj
       press(kk,2)= press(kk,2) + fy * w * detj
 70   CONTINUE
c
cc       write(6,*)N(1),N(2),N(3),jm(1,1)
c
 100   continue
c
ccccc answer
       do 200 k = 1,6
       write(6,*)'NODE',k,press(k,1),press(k,2)
 200   continue
c
 1001  format(2e15.7)
c
       stop
       end
