      program thload
c
      dimension x(10),y(10),DNDXI(10),DNDETA(10)
      dimension axi(10),aeta(10),H(10),sig(4)
      dimension press(8,2)
      dimension bt(20,3),b(3,20)
      real N(10),JM(2,2),JINV(2,2)
ccccc setting node real-coordinate 
ccccc example 1 (rectangle)
      data x(1),y(1),x(2),y(2)/0.0,0.0,0.5,0.0/
      data x(3),y(3),x(4),y(4)/1.0,0.0,1.0,0.5/
      data x(5),y(5),x(6),y(6)/1.0,1.0,0.5,1.0/
      data x(7),y(7),x(8),y(8)/0.0,1.0,0.0,0.5/
c
ccccc example 2 (declined rectangle)
c      data x(1),y(1),x(2),y(2)/-0.5,0.0,0.5,0.5/
c      data x(1),y(1),x(2),y(2)/0.0,0.0,0.5,0.5/
c      data x(3),y(3),x(4),y(4)/1.0,1.0,1.0,1.5/
c      data x(5),y(5),x(6),y(6)/1.0,2.0,0.5,1.5/
c      data x(7),y(7),x(8),y(8)/0.0,1.0,0.0,0.5/
c
c      do 1 i = 1,8
c      write(6,*)x(i),y(i)
c 1    continue
c
ccccc setting initial stress
c  initial stress is defined at each integration points
c
      sig(1) = 1.0
      sig(2) = 1.0
      sig(3) = 0.0
      sig(4) = 0.0
c
      do 2 i = 1,8
         press(i,1)=0.0
         press(i,2)=0.0
 2    continue
c
C   set integration order
      NGAUSS = 2
c
c
      IF (NGAUSS .EQ. 2 ) THEN
      A1 =  sqrt(3.0)/3.0
      NG = 4
      DO 50 I=1,4
      H(I)=1.0
  50  CONTINUE    
      AXI(1)= A1
      AETA(1)=A1
      AXI(2)= A1
      AETA(2)=-A1
      AXI(3)=- A1
      AETA(3)= A1
      AXI(4)=-A1
      AETA(4)=-A1
c
      ELSE  IF (NGAUSS .EQ. 3 ) THEN
      B1= 0.774596669241483
      NG = 9
      H(1)=25.0/81.0
      H(2)=40.0/81.0
      H(3)=25.0/81.0
      H(4)=40.0/81.0
      H(5)=64.0/81.0
      H(6)=40.0/81.0
      H(7)=25.0/81.0
      H(8)=40.0/81.0
      H(9)=25.0/81.0
C
      AXI(1) = B1
      AETA(1)= B1
      AXI(2) = B1
      AETA(2)= 0
      AXI(3) = B1
      AETA(3)=-B1
C
      AXI(4) = 0
      AETA(4)= B1
      AXI(5) = 0
      AETA(5)= 0
      AXI(6) = 0
      AETA(6)=-B1
C
      AXI(7) =-B1
      AETA(7)= B1
      AXI(8) =-B1
      AETA(8)= 0
      AXI(9) =-B1
      AETA(9)=-B1
c
      ENDIF
c
ccccccc each integration points
      DO 100 I = 1, NG
c
      XI = AXI(I)
      ETA= AETA(I)
c
c <N>     
      N(1)=-(1.0-XI)*(1.0-ETA)*(1.0+XI+ETA)/4.0
      N(2)= (1.0-XI*XI)*(1.0-ETA)/2.0
      N(3)=-(1.0+XI)*(1.0-ETA)*(1.0-XI+ETA)/4.0
      N(4)= (1.0+XI)*(1.0-ETA*ETA)/2.0
      N(5)=-(1.0+XI)*(1.0+ETA)*(1.0-XI-ETA)/4.0
      N(6)= (1.0-XI*XI)*(1.0+ETA)/2.0
      N(7)=-(1.0-XI)*(1.0+ETA)*(1.0+XI-ETA)/4.0
ccc true modified by izumi
      N(8)= (1.0-XI)*(1.0-ETA*ETA)/2.0
c
c <dN/dXI>     
      DNDXI(1)=(2.0*XI+ETA)*(1.0-ETA)/4.0
      DNDXI(2)=-(1.0-ETA)*XI
      DNDXI(3)=(1.0-ETA)*(2.0*XI-ETA)/4.0
      DNDXI(4)=(1.0-ETA*ETA)/2.0
      DNDXI(5)=(1.0+ETA)*(2.0*XI+ETA)/4.0
      DNDXI(6)=-XI*(1.0+ETA)
      DNDXI(7)=(1.0+ETA)*(2.0*XI-ETA)/4.0
      DNDXI(8)=-(1.0-ETA*ETA)/2.0
c <dN/dETA>     
      DNDETA(1)=(1.0-XI)*(2.0*ETA+XI)/4.0
      DNDETA(2)=-(1.0-XI*XI)/2.0
      DNDETA(3)=(2.0*ETA-XI)*(1.0+XI)/4.0
      DNDETA(4)=-ETA*(1.0+XI)
      DNDETA(5)=(2.0*ETA+XI)*(XI+1.0)/4.0
      DNDETA(6)=(1.0-XI*XI)/2.0
      DNDETA(7)=(2.0*ETA-XI)*(1.0-XI)/4.0
      DNDETA(8)=-(1.0-XI)*ETA
c
C CALCULATE J-MAT (FOR 2-DIMENSION)
       JM(1,1)=0
       JM(2,1)=0
       JM(1,2)=0
       JM(2,2)=0
       DO 10 J=1,8
       JM(1,1)=JM(1,1)+DNDXI(J)*X(J)
       JM(2,1)=JM(2,1)+DNDETA(J)*X(J)
       JM(1,2)=JM(1,2)+DNDXI(J)*Y(J)
       JM(2,2)=JM(2,2)+DNDETA(J)*Y(J)
 10    CONTINUE
c
        DETJ=JM(1,1)*JM(2,2)-JM(1,2)*JM(2,1)
c
        JINV(1,1)= 1.0/DETJ*JM(2,2)
        JINV(2,1)=-1.0/DETJ*JM(2,1)
        JINV(1,2)=-1.0/DETJ*JM(1,2)
        JINV(2,2)= 1.0/DETJ*JM(1,1)
c       write(6,1001)JM(1,1),JM(1,2)
c       write(6,1001)JM(2,1),JM(2,2)
c
         w = H(I)
c
c
      DO 70 KK=1,8
      I1 = 2*KK-1
      I2 = 2*KK
ccccc setting BMATRIX,BTMATRIX
c      B(1,I1)=JINV(1,1)*DNDXI(KK)+JINV(1,2)*DNDETA(KK)
c      B(1,I2)=0.0
      BT(I1,1)=JINV(1,1)*DNDXI(KK)+JINV(1,2)*DNDETA(KK)
      BT(I2,1)=0.0
c      B(2,I1)=0.0
c      B(2,I2)=JINV(2,1)*DNDXI(KK)+JINV(2,2)*DNDETA(KK)
      BT(I1,2)=0.0
      BT(I2,2)=JINV(2,1)*DNDXI(KK)+JINV(2,2)*DNDETA(KK)
c      B(3,I1)=JINV(2,1)*DNDXI(KK)+JINV(2,2)*DNDETA(KK)
c      B(3,I2)=JINV(1,1)*DNDXI(KK)+JINV(1,2)*DNDETA(KK)
      BT(I1,3)=JINV(2,1)*DNDXI(KK)+JINV(2,2)*DNDETA(KK)
      BT(I2,3)=JINV(1,1)*DNDXI(KK)+JINV(1,2)*DNDETA(KK)
       fx = -(BT(I1,1)*sig(1)+BT(I1,2)*sig(2)+BT(I1,3)*sig(3))
       fy = -(BT(I2,1)*sig(1)+BT(I2,2)*sig(2)+BT(I2,3)*sig(3))
c       write(6,*)fx,fy,w,detj
       press(kk,1)= press(kk,1) + fx * w * detj
       press(kk,2)= press(kk,2) + fy * w * detj
 70   CONTINUE
c
cc       write(6,*)N(1),N(2),N(3),jm(1,1)
c
 100   continue
c
ccccc answer
       do 200 k = 1,8
       write(6,*)'NODE',k,press(k,1),press(k,2)
 200   continue
c
 1001  format(2e15.7)
c
       stop
       end
